#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#include <GL/gl.h>	
#include <GL/glu.h>	

#include "CISG.h"

using namespace vcg;



CISGGroup::~CISGGroup()
{
  iterator i;
	for(i=Sons.begin();i!=Sons.end();++i)
		delete (*i);
}

void CISGGroup::glDraw(const float DocTime)
{
	glPushMatrix();
  iterator i;
	for(i=Sons.begin();i!=Sons.end();++i)
		(*i)->glDraw(DocTime);
	glPopMatrix();
}

void CISGTransformation::glDraw(const float DocTime){ glMultMatrix(m); };

void CISGAnimRotation ::glDraw(const float DocTime) 
{
	float CurAngleRad=ToRad(StartAngleDeg + DocTime*AngularSpeedDPS);
	glRotatef( CurAngleRad, axis[0],axis[1],axis[2]);  
};


CISGAnimZPrecession::CISGAnimZPrecession()
{
	StartAngleDeg=0;
	AngularSpeedDPS=50;
	DeclinationDeg=30;
}
 	
void CISGAnimZPrecession::glDraw(const float DocTime) 
{
	// moto di precessione: una rotazione il cui asse ruota intorno all'asse z
	float CurAngleRad=ToRad(StartAngleDeg + DocTime*AngularSpeedDPS);
	glRotated( DeclinationDeg,cos(CurAngleRad), sin(CurAngleRad),0);  
};
	
